public class ListaDinamicaDuplamenteEncadeada
{
	NoLista inicio;
	
	public ListaDinamicaDuplamenteEncadeada() 
	{
		this.inicio = null;
	} 

	public void insereOrdenado(double valor) 
	{  
	   NoLista novo = new NoLista(valor);
	   
	   NoLista anterior, atual;
	    
	   anterior = null;
	   atual = this.inicio;
	   
	   while(atual != null && atual.info < valor)
	   {
	   	  anterior = atual;
	   	  atual = atual.proximo;  	
	   }
	   
	   if (anterior == null)
	   {
	   	  if (inicio != null)
	   	     inicio.anterior = novo;
	   	     
	   	  novo.proximo = inicio;  	     
	   	  inicio = novo;
	   }
	   
	   else
	   {
	      anterior.proximo = novo;
	      novo.anterior = anterior;
	      
		  novo.proximo = atual;	
		  
		  if(atual != null)
		  {  
		      atual.anterior = novo;
		  }
	   }
	}
	
	public void retira(double valor) {
	    
	   NoLista anterior, atual, temp;
	   
	   if (valor == inicio.info)
	   {
	   	  temp = inicio;
	   	  inicio = inicio.proximo;
	   	  
	   	  if(inicio != null)
	   	     inicio.anterior = null;
	   	     
	   }
	   
	   else
	   {
	   	  anterior = inicio;
	   	  atual = inicio.proximo;
	   	  
	   	  while(atual != null && atual.info != valor)
	   	  {
	   	  	 anterior = atual;
	   	  	 atual = atual.proximo;
	   	  }
	   	  
	   	  if (atual != null)
	   	  {
	   	  	temp = atual;
	   	  	anterior.proximo = atual.proximo;
	   	  	
	   	  	if (atual.proximo != null)
	   	  	{
	   	  	   atual.proximo.anterior = atual.anterior;
	   	  	}
	   	  	
	   	  }
	   	
	   }

    }
    
    /* Imprime os elementos da lista no terminal */  	
	public void imprime()
	{
		for(NoLista q=this.inicio; q != null; q = q.proximo)
		{
			System.out.print(q.info + " ");
		}
		
		System.out.println();
	}
	
	public void imprime_Lista_Inversa()
	{
		NoLista ultimo;
		
		ultimo = this.inicio;
		
		/* Encontrar o ltimo elemento da lista */
		while(ultimo.proximo != null)
		{
			ultimo = ultimo.proximo;
		}
		
		for(NoLista q=ultimo; q != null; q = q.anterior)
		{
			System.out.print(q.info + " ");
		}
		
		System.out.println();
	}
    
}
